typo in backupninja.1
[matthijs/upstream/backupninja.git] / handlers / dup
index 55667f6af63dab9f6fc1e353e703d31deea38d25..edb43ac4b90ddcf8b732f92ae9e7811692e1f48d 100644 (file)
@@ -1,3 +1,4 @@
+# -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
 #
 # duplicity script for backupninja
 # requires duplicity
@@ -11,12 +12,16 @@ setsection gpg
 getconf password
 getconf sign no
 getconf encryptkey
+getconf signkey
 
 setsection source
 getconf include
+getconf vsnames all
+getconf vsinclude
 getconf exclude
 
 setsection dest
+getconf incremental yes
 getconf keep 60
 getconf sshoptions
 getconf bandwidthlimit 0
@@ -27,13 +32,34 @@ destdir=${destdir%/}
 
 [ "$destdir" != "" ] || fatal "Destination directory not set"
 [ "$include" != "" ] || fatal "No source includes specified"
-[ "$password" != "" ] || fatal "No password specified"
 
-# see if we can login
+### vservers stuff ###
+
+# If vservers are configured, check that the ones listed in $vsnames do exist.
+local usevserver=no
+if [ $vservers_are_available = yes ]; then
+   if [ "$vsnames" = all ]; then
+      vsnames="$found_vservers"
+   else
+      if ! vservers_exist "$vsnames" ; then
+            fatal "At least one of the vservers listed in vsnames ($vsnames) does not exist."
+      fi
+   fi
+   if [ -n "$vsinclude" ]; then
+      info "Using vservers '$vsnames'"
+      usevserver=yes
+   fi
+else
+   [ -z "$vsinclude" ] || warning 'vservers support disabled in backupninja.conf, vsincludes configuration lines will be ignored'
+fi
+
+
+### see if we can login ###
+
 if [ "$testconnect" == "yes" ]; then
     debug "ssh $sshoptions -o PasswordAuthentication=no $desthost -l $destuser 'echo -n 1'"
     if [ ! $test ]; then
-       result=`ssh $sshoptions -o PasswordAuthentication=no $desthost -l $destuser 'echo -n 1' 2>&1`
+       result=`ssh $sshoptions -o PasswordAuthentication=no $desthost -l $destuser 'echo -n 1'`
        if [ "$result" != "1" ]; then
            fatal "Can't connect to $desthost as $destuser."
        else
@@ -44,18 +70,47 @@ fi
 
 ### COMMAND-LINE MANGLING ###
 
+# duplicity >= 0.4.2 needs --sftp-command (NB: sftp does not support the -l option)
+duplicity_version="`duplicity --version | @AWK@ '{print $2}'`"
+duplicity_major="`echo $duplicity_version | @AWK@ -F '.' '{print $1}'`"
+duplicity_minor="`echo $duplicity_version | @AWK@ -F '.' '{print $2}'`"
+duplicity_sub="`echo $duplicity_version | @AWK@ -F '.' '{print $3}'`"
+if [ "$duplicity_major" -ge 0 -a "$duplicity_minor" -ge 4 -a "$duplicity_sub" -ge 2 ]; then
+   sftpoptions="$sshoptions"
+fi
+
 scpoptions="$sshoptions"
 [ "$bandwidthlimit" == 0 ] || scpoptions="$scpoptions -l $bandwidthlimit"
 
-execstr="$options --no-print-statistics --scp-command 'scp $scpoptions' --ssh-command 'ssh $sshoptions' "
-
-if [ "$encryptkey" == "" ]; then
-    [ "$sign" != "yes" ] || fatal "encryptkey option must be set when signing."
+if [ -z "$sftpoptions" ]; then
+   execstr="$options --no-print-statistics --scp-command 'scp $scpoptions' --ssh-command 'ssh $sshoptions' "
 else
+   execstr="$options --no-print-statistics --scp-command 'scp $scpoptions' --sftp-command 'sftp $sftpoptions' --ssh-command 'ssh $sshoptions' "
+fi
+
+# deal with symmetric or asymmetric (public/private key pair) encryption
+if [ -n "$encryptkey" ]; then
     execstr="${execstr}--encrypt-key $encryptkey "
-    [ "$sign" != "yes" ] || execstr="${execstr}--sign-key $encryptkey "
+    debug "Data will be encrypted with the GnuPG key $encryptkey."
+else
+    debug "Data will be encrypted using symmetric encryption."
 fi
 
+# deal with data signing
+if [ "$sign" == yes ]; then
+    # duplicity is not able to sign data when using symmetric encryption
+    [ -n "$encryptkey" ] || fatal "The encryptkey option must be set when signing."
+    # if needed, initialize signkey to a value that is not empty (checked above)
+    [ -n "$signkey" ] || signkey="$encryptkey"
+    execstr="${execstr}--sign-key $signkey "
+    debug "Data will be signed will the GnuPG key $signkey."
+else
+    debug "Data won't be signed."
+fi
+
+# deal with GnuPG passphrase
+[ -n "$password" ] || fatal "The password option must be set."
+
 if [ "$keep" != "yes" ]; then
     if [ "`echo $keep | tr -d 0-9`" == "" ]; then
        keep="${keep}D"
@@ -63,46 +118,60 @@ if [ "$keep" != "yes" ]; then
     execstr="${execstr}--remove-older-than $keep "
 fi
 
+if [ "$incremental" == "no" ]; then
+    execstr="${execstr}--full "
+fi
+
 execstr_serverpart="scp://$destuser@$desthost/$destdir"
 execstr_clientpart="/"
 
 ### SOURCE ###
 
+set -o noglob
+
 # excludes
 for i in $exclude; do
-       str="${i//__star__/*}"
-       execstr="${execstr}--exclude $str "
+   str="${i//__star__/*}"
+   execstr="${execstr}--exclude '$str' "
 done
        
 # includes 
 for i in $include; do
-       str="${i//__star__/*}"
-       execstr="${execstr}--include $str "
+   [ "$i" != "/" ] || fatal "Sorry, you cannot use 'include = /'"
+   str="${i//__star__/*}"
+   execstr="${execstr}--include '$str' "
 done
 
-### EXECUTE ###
+# vsincludes
+if [ $usevserver = yes ]; then
+   for vserver in $vsnames; do
+      for vi in $vsinclude; do
+        str="${vi//__star__/*}"
+        str="$VROOTDIR/$vserver$str"
+        execstr="${execstr}--include '$str' "
+      done
+   done
+fi
 
-# exclude everything else, start with root
-#execstr="${execstr}--exclude '**' / "
-               
-# include client-part and server-part
-#execstr="$execstr $execstr_serverpart"
+set +o noglob
+
+### EXECUTE ###
 
 execstr=${execstr//\\*/\\\\\\*}
 
 debug "duplicity $execstr --exclude '**' / $execstr_serverpart"
 if [ ! $test ]; then
+        export PASSPHRASE=$password
        output=`nice -n $nicelevel \
                   su -c \
-                    "export PASSPHRASE=$password \
-                     && duplicity $execstr --exclude '**' / $execstr_serverpart 2>&1"`
+                    "duplicity $execstr --exclude '**' / $execstr_serverpart 2>&1"`
        code=$?
-       if [ "$code" == "0" ]; then
+       if [ $code -eq 0 ]; then
                debug $output
                info "Duplicity finished successfully."
        else
-               warning $output
-               warning "Duplicity failed."
+               debug $output
+               fatal "Duplicity failed."
        fi
 fi